# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`earlyoom`](#earlyoom): Installs earlyoom and configures earlyoom

#### Private Classes

* `earlyoom::config`: Configures earlyoom
* `earlyoom::install`: Installs earlyoom
* `earlyoom::service`: Control earlyoom service

## Classes

### `earlyoom`

Installs earlyoom and configures earlyoom

* **See also**
  * https://github.com/rfjakob/earlyoom
    * earlyoom homepage

#### Examples

##### Simple Example

```puppet
class{'earlyoom':}
```

##### Full Example

```puppet
class{'earlyoom':
  interval        => 120,
  ignore_positive => true,
  notify_send     => true,
  debug           => true,
  priority        => true,
  prefer          => '(^|/)(init|X|sshd|firefox)$',
  avoid           => '(^|/)(cupsd|xrootd)$',
  notify_command  => '/bin/echo ${UID}',
  memory_percent  => 20,
  swap_percent    => [10,4]
  memory_size     => 20000,
  swap_size       => [30000,60000],
  dryrun          => false,
}
```

#### Parameters

The following parameters are available in the `earlyoom` class.

##### `pkgname`

Data type: `String[1]`

Name of package to install

Default value: `'earlyoom'`

##### `interval`

Data type: `Integer[0]`

Memory report interval in seconds

Default value: `60`

##### `configfile`

Data type: `Stdlib::Unixpath`

Full filename of configuration file

Default value: `'/etc/default/earlyoom'`

##### `service_enable`

Data type: `Boolean`

Should the earlyoom service be started.

Default value: ``true``

##### `ignore_positive`

Data type: `Boolean`

If true user-space oom killer should ignore positive oom_score_adj values (-i)

Default value: ``false``

##### `notify_send`

Data type: `Boolean`

If true enable notifications using "notify-send" (-n)

Default value: ``false``

##### `debug`

Data type: `Boolean`

If true enable debug messages (-d)

Default value: ``false``

##### `notify_command`

Data type: `Optional[String[1]]`

Specify a command to enable notifications with. (-N cmd)

Default value: ``undef``

##### `priority`

Data type: `Boolean`

If true set niceness of earlyoom to -20 and oom_score_adj to -1000 (-p)

Default value: ``false``

##### `avoid`

Data type: `Optional[String[1]]`

avoid killing processes matching REGEX (--avoid REGEX)

Default value: ``undef``

##### `prefer`

Data type: `Optional[String[1]]`

avoid killing processes matching REGEX (--prefer REGEX)

Default value: ``undef``

##### `memory_percent`

Data type: `Optional[Variant[Integer[0,100],Array[Integer[0,100],2,2]]]`

set available memory minimum to PERCENT of total
earlyoom sends SIGTERM once below PERCENT, then
SIGKILL once below KILL_PERCENT (default PERCENT/2).
(-m int or -m int,int

Default value: ``undef``

##### `swap_percent`

Data type: `Optional[Variant[Integer[0,100],Array[Integer[0,100],2,2]]]`

set available swap minimum to PERCENT of total
earlyoom sends SIGTERM once below PERCENT, then
SIGKILL once below KILL_PERCENT (default PERCENT/2).
(-s int or -s int,int

Default value: ``undef``

##### `memory_size`

Data type: `Optional[Variant[Integer[0],Array[Integer[0],2,2]]]`

set available memory minimum to SIZE Kib
earlyoom sends SIGTERM once below PERCENT, then
SIGKILL once below KILL_PERCENT (default PERCENT/2).
(-M int or -M int,int

Default value: ``undef``

##### `swap_size`

Data type: `Optional[Variant[Integer[0],Array[Integer[0],2,2]]]`

set available memory minimum to SIZE Kib
earlyoom sends SIGTERM once below PERCENT, then
SIGKILL once below KILL_PERCENT (default PERCENT/2).
(-S int or -S int,int

Default value: ``undef``

##### `dryrun`

Data type: `Boolean`

if true dry run (do not kill any processes) (--dryrun)

Default value: ``false``

